#-----------------------------------------------------------------------------
# Watcom C -3s Makefile for FLC386WS example programs using Watcom extender.
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# These macros and rules are for the watcom 386 c compiler and wmake...
#-----------------------------------------------------------------------------

C_IL	= ..\ # include files path for C
A_IL	= ..\ # include files path for ASM

LFILE	= ..\flc386ws.lib	# lib for watcom extender, stack parms

CC	= wcc386p
CPF = -j -ox -fpi -w2 -3s -g=CGROUP

.c.obj:
	$(CC) $*.c $(CPF) -I$(C_IL) $(EXTCPF) $(CFLAGS)

AS	= 386asm
APF = -80386 -NOLIST -TWOCASE

.asm.obj:
	$(AS) $* $(APF) -i $(A_IL) $(EXTAPF) $(AFLAGS)

#-----------------------------------------------------------------------------
# Targets and dependents...
#-----------------------------------------------------------------------------

FLH = ..\pjltypes.h ..\pjprotos.h ..\pjstypes.h ..\pjecodes.h ..\pjbasics.h $(LFILE)

all:  quickflc.exe playfram.exe copyflic.exe circflic.exe custom.exe ramflic.exe
	@echo Phew - made all the FlicLib examples.>all

quickflc.exe: quickflc.obj $(FLH)
	wlink @stdw.lnk FILE quickflc.obj LIB $(LFILE) NAME quickflc.exe

playfram.exe: playfram.obj $(FLH) ..\pjfli.h
	wlink @stdw.lnk FILE playfram.obj LIB $(LFILE) NAME playfram.exe

copyflic.exe: copyflic.obj $(FLH)
	wlink @stdw.lnk FILE copyflic.obj LIB $(LFILE) NAME copyflic.exe

circflic.exe: circflic.obj $(FLH)
	wlink @stdw.lnk FILE circflic.obj LIB $(LFILE) NAME circflic.exe

custom.exe: custom.obj farcopy.obj $(FLH)
	wlink @stdw.lnk FILE custom.obj,farcopy.obj LIB $(LFILE) NAME custom.exe

ramflic.exe: ramflic.obj $(FLH) ..\pjfli.h
	wlink @stdw.lnk FILE ramflic.obj LIB $(LFILE) NAME ramflic.exe

