#include "pocolib.h"
#include "poco.h"

static void dummy_libfunc() {}

static Lib_proto lib[] = {

/********* User Interface library ***********/
/*
	these ones are coded in MAIN.C

	{dummy_libfunc, "void printf(char *format, ...);"},
	{dummy_libfunc, "void Qtext(char *format, ...);"},
*/
	{dummy_libfunc, "void unprintf();"},
	{dummy_libfunc, "int Qchoice(char **buttons, int bcount, char *header, ...);"},
	{dummy_libfunc, "int Qmenu(char **choices, int ccount, char *header);"},
	{dummy_libfunc, "Boolean Qquestion(char *question, ...);"},
	{dummy_libfunc, "Boolean Qnumber(int *num, int min, int max, char *header);"},
	{dummy_libfunc, "Boolean Qstring(char *string, int size, char *header);"},
	{dummy_libfunc, "Boolean Qfile(char *suffix, char *button, char *inpath, char *outpath, Boolean force_suffix, char *header);"},
	{dummy_libfunc, "Boolean Qlist(int *choice, char **items, int icount, int *ipos, char *header);"},
	{dummy_libfunc, "void Qbusy(char *format, ...);"},
	{dummy_libfunc, "void UnQbusy();"},
	{dummy_libfunc, "ErrCode Qerror(ErrCode err, char *format, ...);"},
	{dummy_libfunc, "Boolean RubBox(int *x, int *y, int *w, int *h);"},
	{dummy_libfunc, "Boolean RubCircle(int *x, int *y, int *rad);"},
	{dummy_libfunc, "Boolean RubLine(int x1, int y1, int *x2, int *y2);"},
	{dummy_libfunc, "int RubPoly(int **x, int **y);"},
	{dummy_libfunc, "void WaitClick(int *x, int *y, int *left, int *right, int *key);"},
	{dummy_libfunc, "void PollInput(int *x, int *y, int *left, int *right, int *key);"},
	{dummy_libfunc, "void WaitInput(int *x, int *y, int *left, int *right, int *key);"},
	{dummy_libfunc, "void SetAbort(Boolean abort);"},
	{dummy_libfunc, "void HideCursor();"},
	{dummy_libfunc, "void ShowCursor();"},

/********* Graphics library ***********/

	{dummy_libfunc, "void GetSize(int *width, int *height);"},
	{dummy_libfunc, "int GetColor();"},
	{dummy_libfunc, "void SetColor(int color);"},
	{dummy_libfunc, "void Clear();"},
	{dummy_libfunc, "void Dot(int x, int y);"},
	{dummy_libfunc, "int GetDot(int x, int y);"},
	{dummy_libfunc, "void Line(int x1, int y1, int x2, int y2);"},
	{dummy_libfunc, "void Box(int x, int y, int w, int h);"},
	{dummy_libfunc, "void Circle(int cx, int cy, int radius);"},
	{dummy_libfunc, "ErrCode Poly(int ptcount, int *x, int *y);"},
	{dummy_libfunc, "ErrCode Spline(int ptcount, int *x, int *y);"},
	{dummy_libfunc, "ErrCode Oval(double angle, int xcen, int ycen, int xrad, int yrad);"},
	{dummy_libfunc, "ErrCode Star(double angle, int xcen, int ycen, int rad);"},
	{dummy_libfunc, "ErrCode Petal(double angle, int xcen, int ycen, int rad);"},
	{dummy_libfunc, "ErrCode Rpoly(double angle, int xcen, int ycen, int rad);"},
	{dummy_libfunc, "ErrCode Spiral(double angle, int xcen, int ycen, int rad, double turns);"},
	{dummy_libfunc, "ErrCode Fill(int x, int y);"},
	{dummy_libfunc, "ErrCode FillTo(int x, int y, int to_color);"},
	{dummy_libfunc, "ErrCode Edge(int color);"},
	{dummy_libfunc, "void WordWrap(int x, int y, int width, int height, char *text);"},
	{dummy_libfunc, "void Text(int x, int y, char *string);"},
	{dummy_libfunc, "void SetColorMap(int index, int r, int g, int b);"},
	{dummy_libfunc, "void GetColorMap(int index, int *r, int *g, int *b);"},

/********* Graphics Modes library ***********/

	{dummy_libfunc, "ErrCode SetInk(char *name);"},
	{dummy_libfunc, "void GetInk(char *buf);"},
	{dummy_libfunc, "void SetInkStrength(int percent);"},
	{dummy_libfunc, "int GetInkStrength();"},
	{dummy_libfunc, "void SetInkDither(Boolean dither);"},
	{dummy_libfunc, "Boolean GetInkDither();"},
	{dummy_libfunc, "void SetFilled(Boolean fill);"},
	{dummy_libfunc, "Boolean GetFilled();"},
	{dummy_libfunc, "void SetBrushSize(int size);"},
	{dummy_libfunc, "int GetBrushSize();"},
	{dummy_libfunc, "void SetKeyMode(Boolean clear);"},
	{dummy_libfunc, "Boolean GetKeyMode();"},
	{dummy_libfunc, "void SetKeyColor(int color);"},
	{dummy_libfunc, "int GetKeyColor();"},
	{dummy_libfunc, "void SetMaskUse(Boolean use_it);"},
	{dummy_libfunc, "Boolean GetMaskUse();"},
	{dummy_libfunc, "void SetMaskCreate(Boolean make_it);"},
	{dummy_libfunc, "Boolean GetMaskCreate();"},
	{dummy_libfunc, "void SetStarPoints(int points);"},
	{dummy_libfunc, "int GetStarPoints();"},
	{dummy_libfunc, "void SetStarRatio(int ratio);"},
	{dummy_libfunc, "int GetStarRatio();"},
	{dummy_libfunc, "void SetSplineTCB(int t, int c, int b);"},
	{dummy_libfunc, "void GetSplineTCB(int *t, int *c, int *b);"},
	{dummy_libfunc, "void SetTwoColorOn(Boolean setit);"},
	{dummy_libfunc, "Boolean GetTwoColorOn();"},
	{dummy_libfunc, "void SetTwoColor(int color);"},
	{dummy_libfunc, "int GetTwoColor();"},
	{dummy_libfunc, "void SetJustify(int just);"},
	{dummy_libfunc, "int GetJustify();"},
	{dummy_libfunc, "void SetClosed(Boolean closed);"},
	{dummy_libfunc, "Boolean GetClosed();"},
	{dummy_libfunc, "void SetCycleDraw(Boolean cycle);"},
	{dummy_libfunc, "Boolean GetCycleDraw();"},

/********* Turtle Graphics library ***********/

	{dummy_libfunc, "void Move(double amount);"},
	{dummy_libfunc, "void Back(double amount);"},
	{dummy_libfunc, "void Left(double angle);"},
	{dummy_libfunc, "void Right(double angle);"},
	{dummy_libfunc, "void PenUp();"},
	{dummy_libfunc, "void PenDown();"},
	{dummy_libfunc, "Boolean IsDown();"},
	{dummy_libfunc, "void MoveTo(double x, double y, double angle);"},
	{dummy_libfunc, "void Where(double *x, double *y, double *angle);"},
	{dummy_libfunc, "void Home();"},

/********* Time Oriented Function library ***********/

	{dummy_libfunc, "void NextFrame();"},
	{dummy_libfunc, "void BackFrame();"},
	{dummy_libfunc, "void SetFrame(int frame);"},
	{dummy_libfunc, "int GetFrame();"},
	{dummy_libfunc, "ErrCode SetFrameCount(int count);"},
	{dummy_libfunc, "int GetFrameCount();"},
	{dummy_libfunc, "void PlayFlic(long frames);"},
	{dummy_libfunc, "void SetSpeed(int speed);"},
	{dummy_libfunc, "int GetSpeed();"},
	{dummy_libfunc, "ErrCode InsertFrames(int count);"},
	{dummy_libfunc, "ErrCode DeleteFrames(int count);"},
	{dummy_libfunc, "ErrCode OverTime(ErrCode (*effect)(double time, void *data), void *data);"},

/********* Cel library ***********/

	{dummy_libfunc, "Boolean CelExists();"},
	{dummy_libfunc, "void CelPaste();"},
	{dummy_libfunc, "void CelMove(int dx, int dy);"},
	{dummy_libfunc, "void CelMoveTo(int x, int y);"},
	{dummy_libfunc, "void CelTurn(double angle);"},
	{dummy_libfunc, "void CelTurnTo(double angle);"},
	{dummy_libfunc, "ErrCode CelNextFrame();"},
	{dummy_libfunc, "ErrCode CelBackFrame();"},
	{dummy_libfunc, "ErrCode CelSetFrame(int frame);"},
	{dummy_libfunc, "int CelGetFrame();"},
	{dummy_libfunc, "int CelFrameCount();"},
	{dummy_libfunc, "ErrCode CelWhere(int *x, int *y, double *angle);"},

/********* Swap Screen library ***********/

	{dummy_libfunc, "Boolean SwapExists();"},
	{dummy_libfunc, "void SwapClip();"},
	{dummy_libfunc, "void SwapRelease();"},

/********* Optics library ***********/

	{NULL,			"typedef struct optState {"},
	{NULL,			"    int pos_count;"},
	{NULL,			"    void  *pos;"},
	{NULL,			"    int path_count;"},
	{NULL,			"    void  *xpath;"},
	{NULL,			"    void  *ypath;"},
	{NULL,			"    char  path_type;"},
	{NULL,			"    char  path_closed;"},
	{NULL,			"    char  outlined;"},
	{NULL,			"    char  el_type;"},
	{NULL,			"    } OptState;"},
	{dummy_libfunc, "void OptClearState();"},
	{dummy_libfunc, "void OptSetState(struct optState *os);"},
	{dummy_libfunc, "void OptGetState(struct optState *os);"},
	{dummy_libfunc, "void OptFreeState(struct optState *os);"},
	{dummy_libfunc, "void OptClearPos();"},
	{dummy_libfunc, "void OptSetPos(struct optPos *op);"},
	{dummy_libfunc, "void OptGetPos(struct optPos *op);"},
	{dummy_libfunc, "void OptClearPath();"},
	{dummy_libfunc, "void OptSetPath(int ptcount, int *x, int *y);"},
	{dummy_libfunc, "int OptGetPath(int **x, int **y);"},
	{dummy_libfunc, "void OptFreePath(int **x, int **y);"},
	{dummy_libfunc, "void OptDefaultCenters();"},
	{dummy_libfunc, "void OptContinue();"},
	{dummy_libfunc, "int OptGetElement();"},
	{dummy_libfunc, "ErrCode OptSetElement(int el);"},
	{dummy_libfunc, "ErrCode OptToFrame(double time);"},
	{dummy_libfunc, "ErrCode OptToSegment(int start, int stop);"},
	{dummy_libfunc, "ErrCode OptToAll();"},

/********* Screen library ***********/

	{dummy_libfunc, "Screen *GetPicScreen();"},
	{dummy_libfunc, "Screen *GetSwapScreen();"},
	{dummy_libfunc, "Screen *GetUndoScreen();"},
	{dummy_libfunc, "ErrCode AllocScreen(Screen **screen, int width, int height);"},
	{dummy_libfunc, "void FreeScreen(Screen **screen);"},
	{dummy_libfunc, "void GetScreenSize(Screen *s, int *x, int *y);"},
	{dummy_libfunc, "void SetPixel(Screen *s, int color, int x, int y);"},
	{dummy_libfunc, "int GetPixel(Screen *s, int x, int y);"},
	{dummy_libfunc, "void SetBlock(Screen *s, char *pixbuf, int x, int y, int width, int height);"},
	{dummy_libfunc, "void GetBlock(Screen *s, char *pixbuf, int x, int y, int width, int height);"},
	{dummy_libfunc, "void IconBlit(char *source, int snext, int sx, int sy, int width, int height, Screen *dest, int dx, int dy, int color);"},
	{dummy_libfunc, "void Blit(Screen *source, int sx, int sy, int width, int height, Screen *dest, int dx, int dy);"},
	{dummy_libfunc, "void KeyBlit(Screen *source, int sx, int sy, int width, int height, Screen *dest, int dx, int dy, int key_color);"},
	{dummy_libfunc, "void CopyScreen(Screen *source, Screen *dest);"},
	{dummy_libfunc, "void TradeScreen(Screen *a, Screen *b);"},

/********* Misc. Functions library ***********/

	{dummy_libfunc, "void exit(ErrCode err);"},
	{dummy_libfunc, "void NewFlic();"},
	{dummy_libfunc, "ErrCode Reset();"},
	{dummy_libfunc, "ErrCode ResizeReset(int width, int height);"},
	{dummy_libfunc, "int PocoVersion();"},
	{dummy_libfunc, "void Redo();"},
	{dummy_libfunc, "void Restore();"},
	{dummy_libfunc, "int rnd(int max);"},
	{dummy_libfunc, "int rand();"},
	{dummy_libfunc, "void srand(int seed);"},
	{dummy_libfunc, "long clock();"},

/********* Autodesk Animator File library ***********/

	{dummy_libfunc, "ErrCode LoadFlic(char *name);"},
	{dummy_libfunc, "ErrCode SaveFlic(char *name);"},
	{dummy_libfunc, "ErrCode LoadPic(char *name);"},
	{dummy_libfunc, "ErrCode SavePic(char *name);"},
	{dummy_libfunc, "ErrCode LoadCel(char *name);"},
	{dummy_libfunc, "ErrCode SaveCel(char *name);"},
	{dummy_libfunc, "ErrCode LoadPath(char *name);"},
	{dummy_libfunc, "ErrCode SavePath(char *name);"},
	{dummy_libfunc, "ErrCode LoadPoly(char *name);"},
	{dummy_libfunc, "ErrCode SavePoly(char *name);"},
	{dummy_libfunc, "ErrCode LoadColors(char *name);"},
	{dummy_libfunc, "ErrCode SaveColors(char *name);"},
	{dummy_libfunc, "ErrCode LoadTitles(char *name);"},
	{dummy_libfunc, "ErrCode SaveTitles(char *name);"},
	{dummy_libfunc, "ErrCode LoadMask(char *name);"},
	{dummy_libfunc, "ErrCode SaveMask(char *name);"},
	{dummy_libfunc, "ErrCode LoadFont(char *name);"},

/********* (C Standard) FILE library ***********/

/*
	{dummy_libfunc, "FILE *fopen(char *name, char *mode);"},
	{dummy_libfunc, "void fclose(FILE *f);"},
	{dummy_libfunc, "int fread(void *buf, int size, int count, FILE *f);"},
	{dummy_libfunc, "int fwrite(void *buf, int size, int count, FILE *f);"},
	{dummy_libfunc, "int fprintf(FILE *f, char *format, ...);"},
	{dummy_libfunc, "int fseek(FILE *f, long offset, int mode);"},
	{dummy_libfunc, "long ftell(FILE *f);"},
	{dummy_libfunc, "int fflush(FILE *f);"},
	{dummy_libfunc, "int getc(FILE *f);"},
	{dummy_libfunc, "int fgetc(FILE *f);"},
	{dummy_libfunc, "int putc(int c, FILE *f);"},
	{dummy_libfunc, "int fputc(int c, FILE *f);"},
	{dummy_libfunc, "char *fgets(char *s, int maxlen, FILE *f);"},
	{dummy_libfunc, "int fputs(char *s, FILE *f);"},
*/
/********* (C standard) String library ***********/
/*
	{dummy_libfunc, "int sprintf(char *buf, char *format, ...);"},
	{dummy_libfunc, "int strcmp(char *a, char *b);"},
	{dummy_libfunc, "int stricmp(char *a, char *b);"},
	{dummy_libfunc, "int strncmp(char *a, char *b, int maxlen);"},
	{dummy_libfunc, "int strlen(char *a);"},
	{dummy_libfunc, "char *strcpy(char *dest, char *source);"},
	{dummy_libfunc, "char *strncpy(char *dest, char *source, int maxlen);"},
	{dummy_libfunc, "char *strcat(char *dest, char *source);"},
	{dummy_libfunc, "char *strdup(char *source);"},
	{dummy_libfunc, "char *strstr(char *string, char *substring);"},
	{dummy_libfunc, "char *stristr(char *string, char *substring);"},
*/
/********* (C Standard) Memory Manager library ***********/
/*
	{dummy_libfunc, "void *malloc(int size);"},
	{dummy_libfunc, "void *calloc(int size_el, int el_count);"},
	{dummy_libfunc, "void free(void *pt);"},
	{dummy_libfunc, "void *memcpy(void *dest, void *source, int size);"},
	{dummy_libfunc, "void *memmove(void *dest, void *source, int size);"},
	{dummy_libfunc, "int memcmp(void *a, void *b, int size);"},
	{dummy_libfunc, "void *memset(void *dest, int source, int size);"},
*/
/********* (C Standard) Math library ***********/
/*
	{dummy_libfunc, "double  acos(double x);"},
	{dummy_libfunc, "double  asin(double x);"},
	{dummy_libfunc, "double  atan(double x);"},
	{dummy_libfunc, "double  atan2(double y, double x);"},
	{dummy_libfunc, "double  ceil(double x);"},
	{dummy_libfunc, "double  cos(double x);"},
	{dummy_libfunc, "double  cosh(double x);"},
	{dummy_libfunc, "double  exp(double x);"},
	{dummy_libfunc, "double  fabs(double x);"},
	{dummy_libfunc, "double  floor(double x);"},
	{dummy_libfunc, "double  fmod(double x, double y);"},
	{dummy_libfunc, "double  log(double x);"},
	{dummy_libfunc, "double  log10(double x);"},
	{dummy_libfunc, "double  pow(double x, double y);"},
	{dummy_libfunc, "double  sin(double x);"},
	{dummy_libfunc, "double  sinh(double x);"},
	{dummy_libfunc, "double  sqrt(double x);"},
	{dummy_libfunc, "double  tan(double x);"},
	{dummy_libfunc, "double  tanh(double x);"},
*/
/********* DOS library ***********/

	{dummy_libfunc, "ErrCode fnsplit(char *path, char *device, char *dir, char *file, char *suf);"},
	{dummy_libfunc, "ErrCode fnmerge(char *path, char *device, char *dir, char *file, char *suf);"},
	{dummy_libfunc, "Boolean DosExists(char *filename);"},
	{dummy_libfunc, "ErrCode DosCopy(char *source, char *dest);"},
	{dummy_libfunc, "ErrCode DosDelete(char *filename);"},
	{dummy_libfunc, "ErrCode DosRename(char *old, char *new);"},
	{dummy_libfunc, "ErrCode SetDir(char *dir);"},
	{dummy_libfunc, "ErrCode GetDir(char *dir);"},
	{dummy_libfunc, "int DirList(char ***list, char *wild, Boolean get_dirs);"},
	{dummy_libfunc, "void FreeDirList(char ***list);"},
	{dummy_libfunc, "ErrCode LoadPoe(void **prex, char *name);"},
	{dummy_libfunc, "ErrCode RunPoe(void **prex, int magic, ...);"},
	{dummy_libfunc, "void FreePoe(void **prex);"},
	};

Poco_lib po_dummy_lib = {
	NULL,
	"Ian's dummy libs",
	lib,
	Array_els(lib),
	};
